public class Main_3_Comps_Exhaustive {

	public static void main(String[] args) {
		try {

			Architecture arch = new Architecture(3, 3);
			arch.setProcessMemReq(21);
			arch.setAvailableMem(200);
			arch.setProcessCPUReq(107);
			arch.setAvailableCPU(1000);

			// Communication Connector
			arch.setComponentReliability(0, 0.999);
			arch.deployComponent(0, 1);
			arch.setMaxReplicas(0, 1);
			arch.setComponentMemUsage(0, 10);
			arch.setComponentCPUUsage(0, 100);
			// Controller
			arch.setComponentReliability(1, 0.997);
			arch.deployComponent(1, 2);
			arch.setMaxReplicas(1, 1);
			arch.setComponentMemUsage(1, 20);
			arch.setComponentCPUUsage(1, 150);
			// Navigator
			arch.setComponentReliability(2, 0.998);
			arch.deployComponent(2, 0);
			arch.setMaxReplicas(2, 1);
			arch.setComponentMemUsage(2, 15);
			arch.setComponentCPUUsage(2, 120);

			// System Operational Profile
			double[][] opProfile = new double[4][4];
			opProfile[0][1] = 1;
			opProfile[1][2] = 0.5;
			opProfile[2][1] = 1;
			opProfile[1][3] = 0.5;
//			opProfile[3][4] = 1;
//			opProfile[1][4] = 0.25;

			arch.setOperationalProfile(opProfile);

			// Display current architecture
			System.out.println("Start : ");
//			arch.show();
			// Show Optimum architecture
			long start = System.currentTimeMillis();
			arch.optimizeByExhaustiveSearch(99);
			long elapsedTimeMillis = System.currentTimeMillis() - start;
			System.out.println("Elapsed time : " + elapsedTimeMillis);


		} catch (Exception ex) {
			System.out.print(ex.toString());
		}
	}
}